# knowledge

### 数据模型

1. 知识库类型
2. 知识库数据

### 数据关说明

1. 知识库中的数据，原则上只做增加
2. 知识库类型保存知识库数据对应的大类
3. 知识库数据保存实际的知识库类型对应的知识数据

### 数据结构

| 知识库类型（kl_tpye） |                    |              |                                 |
| :-------------------: | :----------------: | :----------: | :-----------------------------: |
|         字段          |      字段说明      |   数据类型   |              备注               |
|          id           | 主键（无业务含义） | varchar(20)  | id全局唯一，命名规则：“KL”+UUID |
|         code          |     知识库编码     | varchar(40)  |                                 |
|         name          |   知识库类型名称   | varchar(40)  |                                 |
|      description      |        描述        | varchar(500) |        对知识库类型描述         |
|        status         |        状态        |   char(2)    |        0：停用，1：正常         |
|      create_time      |      创建时间      |   datetime   |                                 |
|       create_by       |      创建人员      | varchar(40)  |        保存创建的用户id         |
|      update_time      |      更新时间      |   datetime   |                                 |
|       update_by       |      更新人员      | varchar(40)  |      保存最后更新的用户id       |
|        remark         |      备注信息      | varchar(200) |                                 |

| 知识库数据（kl_data） |                    |              |                                        |
| :-------------------: | :----------------: | :----------: | :------------------------------------: |
|         字段          |      字段说明      |   数据类型   |                  备注                  |
|          id           | 主键（无业务含义） | varchar(20)  |                  UUID                  |
|      kl_tpye_id       |    知识库类型id    | varchar(20)  |                                        |
|      parent_code      |       父节点       | varchar(20)  | 保存多级树状知识库（id），没有可以不写 |
|     kl_type_code      |     知识库类型     | varchar(40)  |           对应知识库类型编码           |
|         code          |        编码        | varchar(40)  |                                        |
|         label         |        名称        | varchar(40)  |                                        |
|         value         |   知识库其他字段   | varchar(500) |              保存json格式              |
|        status         |        状态        |   char(2)    |            0：停用，1：正常            |
|        remark         |      备注信息      | varchar(200) |                                        |



## 接口

```json
{
  "code":"",
  "name":"",
  "userId":"",
  "description":"知识库类型描述",
  "data":[
    { 
      "parentCode":"",//用于多层级知识库数据，没有可为空
      "kl_tpye_id":"",
      "code":"",
      "label":"",
      "value":[
        {
          //根据值拼装json字符串
        }
      ]
    }
  ]
}
```

